﻿using Builder.Builder;
using Builder.Builders;

namespace Builder
{
	internal class Program
	{
		static void Main(string[] args)
		{
			Director director = new Director();
			ConcreteBuilder builder = new ConcreteBuilder();
			director.Builder = builder;

			Console.WriteLine("Standard basic prodcut: ");
			director.BuildMinimalVariableProduct();
			Console.WriteLine(builder.GetProduct().ListParts());

			Console.WriteLine("Standard full featured product: ");
			director.BuildMaximumVariableProduct();
			Console.WriteLine(builder.GetProduct().ListParts());

			Console.WriteLine("Custom product: ");
			builder.BuildPartA();
			builder.BuildPartC();
			Console.WriteLine(builder.GetProduct().ListParts());
		}
	}
}