﻿using Decorator.Components;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace Decorator.Decorators
{
	abstract class Decorator : Component
	{
		protected Component _component;

		public Decorator(Component component)
		{
			_component = component;
		}

		public void SetComponent(Component component)
		{
			_component = component;
		}

		public override string Operation()
		{
			if (_component == null)
				return String.Empty;

			return _component.Operation();
		}
	}
}
